#ifndef INC_GTAPPSHELL_H
#define INC_GTAPPSHELL_H

#include "gtshell.h"
#include "gtcblist.h"
#include "gtdlink.h"

/************************************************************************\
*
* GtAppShell class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

class GtAppShell : public GtShell
{
public:
		/* Standard */
	GtAppShell(void);
	void Destroy(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtAppShell"); }
	sbool IsSubClassOf(char *cn);
		/* Window management */
	sbool Build(void);
		/* Events */
	int Handle(XEvent *xe);
		/* Layout */
	void Relayout(void);
		/* Values */
	void SetEMask(ulong em);
		/* Callbacks */
	void AddCB(ulong tag,GtCallB cb,GtUDPtr ud);
	void RemCB(ulong tag,GtCallB cb);
	int AddKeyCB(char *kstr,GtCallB cb,GtUDPtr ud);
	void RemKeyCB(int id);
	int AddButtonCB(ulong button,ulong state,GtCallB cb,GtUDPtr ud);
	void RemButtonCB(int id);
		/* Colormap management */
	void UpdateColormaps(void);
protected:
		/* Internal methods */
	sbool Key(XEvent *xe);
	sbool Mouse(XEvent *xe);
	sbool Misc(XEvent *xe);
private:
	int CountColormaps(GtWList *wl);
	Window *ColormapWindows(GtWList *wl,Window *wp);
protected:
		/* Instance variables */
	GtCBList close,key;
	GtDLink khd,bhd;
	Window grp;
	char *title,*icon,*geom;
	int xinc,yinc;
	Atom delat,protat,clat;
	XSizeHints *szht;
	sbool cmaps,iconic,nominmax;
};

extern GtAppShell *GtMkAppShell(char *n,GtManager *p,GtTag *tgs);
extern GtAppShell *GtMkAppShell(char *n,GtManager *p,ulong tag,...);
extern GtAppShell *GtMkAppShell(char *n,GtAppDisp *p,GtTag *tgs);
extern GtAppShell *GtMkAppShell(char *n,GtAppDisp *p,ulong tag,...);

#endif /* INC_GTAPPSHELL_H */
